C Soluo do exerccio de fixao 1 do conjunto de slides 09. O programa
C l valores reais que so colocados em uma matriz NxM. Os valores de N
C e M so definidos pelo programador como PARAMETER. Em seguida, o
C programa calcula a transposta da matriz informada e exibe ambas as
C matrizes. A leitura, processamento e escrita das matrizes  feita por
C meio de sub-rotinas.

      program au22ex1
      
C     Declarao de parmetros.
      integer N, M
      parameter (N = 2, M = 3)
      
C     Declarao de variveis.
      real X(N,M), T(M,N)

C     Leitura, processamento e escrita das matrizes.
      call LerMatriz(X,N,M,'X')
      call TransporMatriz(X,T,N,M)
      call EscreverMatriz(X,N,M,'X')
      call EscreverMatriz(T,M,N,'T')

      end


C Sub-rotina para leitura de uma matriz. Os argumentos Matriz, NumLinhas
C e NumColunas correspondem  matriz bidimensional de valores reais a
C ser lida, com NumLinhas linhas e NumColunas colunas. O argumento
C NomeMatriz  um nico caractere que identifica o nome da matriz do
C ponto de vista do usurio.
      subroutine LerMatriz(Matriz,NumLinhas,NumColunas,NomeMatriz)

C     Declarao de argumentos.
      integer NumLinhas, NumColunas
      real Matriz(NumLinhas,NumColunas)
      character NomeMatriz

C     Declarao de variveis locais.
      integer iLin, iCol

C     Declarao de rtulos de formatao.
1     format(/,'Por favor, informe os coeficientes reais',
     >       /,'da matriz ',A1,' com ',I1,' linhas e ',I1,' colunas',/)

2     format('  ',A1,'(',I1,',',I1,') = ',$)

C     Interao com o usurio.
      print 1, NomeMatriz, NumLinhas, NumColunas

      do iLin = 1, NumLinhas
        do iCol = 1, NumColunas
          print 2, NomeMatriz, iLin, iCol
          read *, Matriz(iLin,iCol)
        end do
      end do

      end


C Sub-rotina que transpe a matriz informada no argumento Matriz,
C atribuindo o resultado  matriz informada no argumento Resultado. Os
C argumentos Tamanho1 e Tamanho2, correspondem, respectivamente, ao
C nmero de linhas e colunas de Matriz e, conseqentemente, ao nmero de
C colunas e linhas de Resultado.
      subroutine TransporMatriz(Matriz,Resultado,Tamanho1,Tamanho2)
      
C     Declarao de argumentos.
      integer Tamanho1, Tamanho2
      real Matriz(Tamanho1,Tamanho2), Resultado(Tamanho2,Tamanho1)

C     Declarao de variveis locais.
      integer i1, i2
      
      do i1 = 1, Tamanho1
        do i2 = 1, Tamanho2
          Resultado(i2,i1) = Matriz(i1,i2)
        end do
      end do

      end


C Sub-rotina para escrita de uma matriz. Os argumentos Matriz, NumLinhas
C e NumColunas correspondem  matriz bidimensional de valores reais a
C ser escrita, com NumLinhas linhas e NumColunas colunas. O argumento
C NomeMatriz  um nico caractere que identifica o nome da matriz do
C ponto de vista do usurio.
      subroutine EscreverMatriz(Matriz,NumLinhas,NumColunas,NomeMatriz)

C     Declarao de argumentos.
      integer NumLinhas, NumColunas
      real Matriz(NumLinhas,NumColunas)
      character NomeMatriz

C     Declarao de variveis locais.
      integer iLin, iCol

C     Declarao de rtulos de formatao. Note que os rtulos podem ser
C     os mesmos utilizados em outro subprograma ou no programaprincipal,
C     pois o rtulo  um elemento local. Ou seja, s  conhecido dentro
C     do escopo onde foi declarado. No caso, a sub-rotina.
1     format(/,'Matriz ',A1,' = ',$)

2     format('           ',F6.2,' ',$) ! Col. 1, linhas 2 a ltima linha
3     format(F6.2)                     ! ltima coluna
4     format(F6.2,' ',$)               ! Todos os outros casos

C     Interao com o usurio.
      print 1, NomeMatriz

      do iCol = 1, NumColunas-1
        print 4, Matriz(1,iCol)
      end do
      print 3, Matriz(1,NumColunas)

      do iLin = 2, NumLinhas
        print 2, Matriz(iLin,1)
        do iCol = 2, NumColunas-1
          print 4, Matriz(iLin,iCol)
        end do
        print 3, Matriz(iLin,NumColunas)
      end do

      end
