C Soluo do exerccio de fixao 2 do conjunto de slides 09. O programa
C l valores inteiros que so colocados em uma matriz NxM. Os valores de
C N e M so definidos pelo programador como PARAMETER. Em seguida, o
C programa pede ao usurio um ndice inteiro indo de 1 a N*M, e como
C resposta informa a matriz lida e o valor armazenado na posio
C indexada. A leitura da matriz, processamento e escrita da matriz 
C feita por sub-rotinas.

      program au22ex2
      
C     Declarao de parmetros.
      integer N, M
      parameter (N = 3, M = 4)
      
C     Declarao de variveis.
      integer X(N,M), Indice, Linha, Coluna

C     Leitura, processamento e escrita da matriz e do valor indexado.
      call LerMatriz(X,N,M,'X')
      call LerInteiro(Indice,1,N*M)

      call ConverterIndice(Indice,Linha,Coluna,M)

      call EscreverMatriz(X,N,M,'X')

1     format(/,'O valor armazenado na posio ',I2.2,' da matriz ',A1,
     >       '  o ',I2.2,'.')
      print 1, Indice, 'X', X(Linha,Coluna)

      end


C Sub-rotina para leitura de uma matriz. Os argumentos Matriz, NumLinhas
C e NumColunas correspondem  matriz bidimensional de valores inteiros a
C ser lida, com NumLinhas linhas e NumColunas colunas. O argumento
C NomeMatriz  um nico caractere que identifica o nome da matriz do
C ponto de vista do usurio.
      subroutine LerMatriz(Matriz,NumLinhas,NumColunas,NomeMatriz)

C     Declarao de argumentos.
      integer NumLinhas, NumColunas
      integer Matriz(NumLinhas,NumColunas)
      character NomeMatriz

C     Declarao de variveis locais.
      integer iLin, iCol

C     Declarao de rtulos de formatao.
1     format(/,'Por favor, informe os coeficientes inteiros',
     >       /,'da matriz ',A1,' com ',I1,' linhas e ',I1,' colunas',/)

2     format('  ',A1,'(',I1,',',I1,') = ',$)

C     Interao com o usurio.
      print 1, NomeMatriz, NumLinhas, NumColunas

      do iLin = 1, NumLinhas
        do iCol = 1, NumColunas
          print 2, NomeMatriz, iLin, iCol
          read *, Matriz(iLin,iCol)
        end do
      end do

      end
      
C Sub-rotina que l um valor inteiro e armazena no argumento Resultado.
C Este subprograma garante que o valor lido estar no intervalo
C Min <= Resultado <= Max.
      subroutine LerInteiro(Resultado,Min,Max)
      
C     Declarao de argumentos.
      integer Resultado, Min, Max
      
C     Declarao de rtulos de formatao.
1     format(/,'Informe um valor inteiro no intervalo [',I2.2,',',
     >       I2.2,']: ',$)

2     format(/,'O valor informado est fora do intervalo [',I2.2,',',
     >       I2.2,'].',/,'Por favor, informe outro valor: ',$)
     
C     Interao com o usurio.
      print 1, Min, Max
      read *, Resultado
      
      do while ((Resultado .lt. Min) .or. (Max .lt. Resultado))
        print 2, Min, Max
        read *, Resultado
      end do
      
      end


C     Sub-rotina que converte um ndice inteiro em coordenadas de linha
C     e coluna. Como argumentos da sub-rotina so esperados um Indice
C     maior ou igual a 1, as coordenadas resultantes Linha e Coluna, e
C     a quantidade de colunas da matriz, informada e NumColunas.
      subroutine ConverterIndice(Indice,Linha,Coluna,NumColunas)

C     Declarao de argumentos.
      integer Indice, Linha, Coluna, NumColunas

C     Clculo do ndide da linha e da coluna.
      Linha = (Indice - 1) / NumColunas + 1
      Coluna = mod(Indice - 1, NumColunas) + 1

      end
      
      
C Sub-rotina para escrita de uma matriz. Os argumentos Matriz, NumLinhas
C e NumColunas correspondem  matriz bidimensional de valores inteiros a
C ser escrita, com NumLinhas linhas e NumColunas colunas. O argumento
C NomeMatriz  um nico caractere que identifica o nome da matriz do
C ponto de vista do usurio.
      subroutine EscreverMatriz(Matriz,NumLinhas,NumColunas,NomeMatriz)

C     Declarao de argumentos.
      integer NumLinhas, NumColunas
      integer Matriz(NumLinhas,NumColunas)
      character NomeMatriz

C     Declarao de variveis locais.
      integer iLin, iCol

C     Declarao de rtulos de formatao. Note que os rtulos podem ser
C     os mesmos utilizados em outro subprograma ou no programaprincipal,
C     pois o rtulo  um elemento local. Ou seja, s  conhecido dentro
C     do escopo onde foi declarado. No caso, a sub-rotina.
1     format(/,'Matriz ',A1,' = ',$)

2     format('           ',I2.2,' ',$) ! Col. 1, linhas 2 a ltima linha
3     format(I2.2)                     ! ltima coluna
4     format(I2.2,' ',$)               ! Todos os outros casos

C     Interao com o usurio.
      print 1, NomeMatriz

      do iCol = 1, NumColunas-1
        print 4, Matriz(1,iCol)
      end do
      print 3, Matriz(1,NumColunas)

      do iLin = 2, NumLinhas
        print 2, Matriz(iLin,1)
        do iCol = 2, NumColunas-1
          print 4, Matriz(iLin,iCol)
        end do
        print 3, Matriz(iLin,NumColunas)
      end do

      end
